#include <stdio.h>
#include "pbar.h"

float bcm_voltage (char *filename) {
  
  float x,y;
  FILE *fp;
  double sum=0;
  double mean=0;
  int i=0;

  /* BCM window */
  fp = fopen(filename, "r");
  if (fp == NULL) {
    printf("*** WARNING: Could not open BCMfile.\n");
    return(BCM_ERROR_RETURN_CODE); 

  }
  
  sum = 0;
  while (fscanf(fp, "%f %f\n", &x, &y) != EOF){
    /* set the averaging window */
    if (( x > BCM_INT_LOWER ) && ( x < BCM_INT_UPPER )) {
      sum += y;
      ++i;
    }
  }
  fclose(fp);
  mean = sum / (float) i;
  return( (float) mean);
}



float sci_integration (char *filename) {

  float x,dx,y;
  //  float x0 =0;
  FILE *fp;
  double sum=0;
  double mean=0;
  int i=0, j=0;

  fp = fopen(filename, "r");
  if (fp == NULL) {
    printf("*** WARNING: Could not open file for SCI integration.\n");
    return(0.0); /* this is poor, error returns should be negative */
  }
  // **********************************
/*   sum = 0; /\* only integrate the first SCI_INT_PTS data points *\/ */
/*   while ((fscanf(fp, "%f %f\n", &x, &y) != EOF) && (i < SCI_INT_PTS)){ */
/*     sum += y; */
/*     ++i; */
/*   } */
/*   mean = sum / (float) SCI_INT_PTS; */
  
/*   sum=0; */
/*   x0 = 0; */
/*   while (fscanf(fp, "%f %f\n", &x, &y) != EOF) {     */
/*     dx = x-x0;  */
/*     sum += (double) ((y-mean)*dx); */
/*     x0 = x; */
/*   } */
  // ********************************************

  sum = 0;
  while (fscanf(fp, "%f %f\n", &x, &y) != EOF){
    /* set the averaging window */
    if (( x > SCI_INT_LOWER ) && ( x < SCI_INT_UPPER )) {
      sum += y;
      ++i;
    }
    if (( x > SCI_INT_LOWER_BGR ) && ( x < SCI_INT_UPPER_BGR )) {
      mean += y;
      ++j;
    }
  }
  mean /= (float) j; // mean background level

  // sum = sum * delta_x
  dx = (SCI_INT_UPPER - SCI_INT_LOWER) / ((float) i);
  sum *= dx;
  //  sum -= (i*mean);  // subtract i times the background
  
  //printf("i j dx %i %i %e \n",i,j,dx );

  
  // printf("%e\n", sum);
  fclose(fp);
  return(sum);
}
