/* global file with defines, partially used by multiple programs */

#define FILENAME_EVENT_LOG "/data/incoming/log.txt"
#define FILENAME_DATA_LOG  "/data/incoming/log_data.txt"

#define DATA_PATH_SCI   "/data/incoming/SCI/"
#define DATA_PATH_BCM   "/data/incoming/BCM/"
#define DATA_PATH_CCD   "/data/incoming/CCD/"
//#define DATA_FILE_CCD   "./out.fits"
#define NPBAR_DATA_FILE "/data/incoming/NPBAR/NPBAR_DATA.dat"


//#define NPBAR_FILENAME_LAST_SHOT "/data/incoming/Last_shot.txt"
// in this version, we do grab the npbars from the sshfs directly
#define NPBAR_FILENAME_LAST_SHOT "/mnt/npbar/Transfo.xml_log0"

#define NPBAR_NOISE_THRESHOLD  0.05 /* only record if value about this */


#define GET_TRACE_COMMAND      "./get_trace_9450_fifo %i %i %i %s &" /* fifodev addr chan */

#define PARPORT_TRIGGER_DAEMON_COMMAND "./parport_trigger_daemon_v2"
#define PARPORT_TRIGGER_DAEMON_COMMAND_HEIKKI "./parport_trigger_daemon_v2_heikki"
//#define PARPORT_TRIGGER_DAEMON_COMMAND "./parport_trigger_daemon_test"
#define GET_NPBAR_COMMAND      "./get_last_npbar.sh > /dev/null"
#define CCD_EXPOSE_COMMAND     "./test_apogeepci_nb -i %s.fits -t %i -s 1 > /dev/null &"

#define PBAR_CONV_FILENAME  "./pbar_conv.dat"
#define PBAR_CONV_DEGR_FILENAME  "./pbar_conv.dat"

#define OSC_CHANNEL_SCI    1    /* SCI connected to channel 1 */
#define OSC_CHANNEL_BCM    2    /* BCM connected to channel 2 */
#define OSC_GPIBADDR       4    /* GBIP Address */

#define UNIDOS_EXP_TIME   15    /* unidos exposure time in seconds */
#define UNIDOS_DATA_FILE "/data/incoming/UNIDOS/UNIDOS_DATA.dat"

#define BCM_INT_LOWER    100e-6 /* BCM integration window lower val (s) */
#define BCM_INT_UPPER    300e-6 /* BCM integration window upper val (s) */

#define SCI_INT_LOWER    1e-6   /* integration window */
#define SCI_INT_UPPER    10e-6  
/* ------------------------------------------- */
/* CAUTION:  SCI_INT_UPPER > SCI_INT_LOWER_BGR */
/* ------------------------------------------- */
#define SCI_INT_LOWER_BGR 30e-6  /* for bias subtraction */
#define SCI_INT_UPPER_BGR 70e-6

#define CYCLES_AVR        10      /* average over 10 shots */
#define TRIGGER_LOCKOUT_TIME   80 /* default. prohibit exec for 80 seconds */
/* ------------------------------------------------------- 

   Internal stuff follows, do not change 

   ------------------------------------------------------- */
#define FIFO_PBAR   "/tmp/fifo_dev_pbar"
#define FIFO_NPBAR  "/tmp/fifo_dev_npbar"
#define FIFO_UNIDOS "/tmp/fifo_dev_unidos"
#define FIFO_BCM    "/tmp/fifo_dev_bcm"
#define FIFO_SCI    "/tmp/fifo_dev_sci"
#define FIFO_TEST0  "/tmp/fifo_dev_test0"
#define FIFO_TEST1  "/tmp/fifo_dev_test1"
#define FIFO_HEIKKI "/tmp/fifo_dev_heikki"

#define DEV_NONE   0
#define DEV_NPBAR  1
#define DEV_UNIDOS 2
#define DEV_BCM    3
#define DEV_SCI    4
#define DEV_CCD    5

//#define CURRENT_PID_NAME "./current_pid"
//#define DATA_READY_NAME "./data_ready.dat"

#define READBUF_SIZE 256  // FIFO BYTES + 1 

#define BCM_ERROR_RETURN_CODE -65535 /* 2**16-1 : this magic number is very 
					unlikely to be measured by the BCM 
					in this experiment so this is used 
					as an error return code */
#define SCI_ERROR_RETURN_CODE -65535 /* d.o. for the SCI.*/
